dynamic ip and mail port updates
[distro-setup] / switch-mail-host
1 #!/bin/bash
2 set -x
3 set -eE -o pipefail
4 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
5
6 usage() {
7 cat <<EOF
8 Usage: ${0##*/} OLD_HOST NEW_HOST
9
10 Adjust home network dns so NEW_HOST resolves locally if it is on the
11 local network. Turn off mail receiving on OLD_HOST, run btrbk to move
12 mail to NEW_HOST, turn on mail receiving on NEW_HOST.
13
14 -w Don't try to ssh to wrt. Should only be used in unusual network situation.
15 -h|--help Print help and exit.
16
17 Note: Uses GNU getopt options parsing style
18 EOF
19 exit $1
20 }
21
22 ##### begin command line parsing ########
23
24 update_wrt=true # default
25 temp=$(getopt -l help wh "$@") || usage 1
26 eval set -- "$temp"
27 while true; do
28 case $1 in
29 -w) update_wrt=false; shift ;;
30 -h|--help) usage ;;
31 --) shift; break ;;
32 *) echo "$0: Internal error! unexpected args: $*" ; exit 1 ;;
33 esac
34 done
35
36
37 (( $# == 2 )) || usage 1
38
39 old_host=$1
40 new_host=$2
41 source /a/bin/bash_unpublished/source-semi-priv
42
43 if [[ $old_host != $MAIL_HOST ]]; then
44 read -p "warning: \$old_host != \$MAIL_HOST: $old_host != $MAIL_HOST, proceed? y/N "
45 if [[ $REPLY != [yY] ]]; then
46 exit 1
47 fi
48 fi
49
50 if [[ $new_host == "$HOSTNAME" ]]; then
51 localhost_new=true
52 new_shell=
53 else
54 localhost_new=false
55 new_shell="ssh $new_host"
56 fi
57
58 old_shell="ssh $old_host"
59 if [[ $old_host == "$HOSTNAME" ]]; then
60 old_shell=
61 fi
62
63 if [[ ! $new_host || ! $old_host ]]; then
64 echo "$0: bad args. see script"
65 exit 1
66 fi
67
68 # TODO: make home dns use ipv6. for work, make a cronjob that updates
69 # the dns there.
70 #
71 # This exists because if mail_host is on the home network with a vpn
72 # tunnel, and another host on the home network tries to connect to the
73 # public tunnel ip, it won't work because from the public machine's
74 # perspective, due to nat, both home network machines have the same
75 # ip. We could solve this by using ipv6 addresses, but not all networks
76 # i'm on with more than one machine are ipv6 enabled.
77 at_home=false
78 if timeout -s 9 5 ssh-keyscan -p 2220 -t rsa 10.0.0.1 2>/dev/null | grep -qFx '[10.0.0.1]:2220 ssh-rsa AAAAB3NzaC1yc2EAAAADAQABAAABAQCH+/h1dGEfKEusBblndU2e6QT4wLCm5+yqr/sqh/0X9YfjR7BfWWm8nNmuP55cYc+Wuf5ljB1H1acXEcsl1y8e0j3agHfF0V74FE1N1zz5nn2Ep8NHnmqgEhza38ZxMPh+4p3X7zklEKU7+3SzybKBi8sg0wLzlS2LM0JaUN80zR2sK11Kye3dURUXPk78u5wodOkgcEYRwSYaDMJlUzWP+poRXIDJwFaMQnwmxbl/c84yOyaU0x/d6hFwoRscWecihX+vvBNeSyxR4xr2HDOyUWwJkctyAgt2p7w3tfkXOKcCRzTAjGVIMQLTvo0sG/yJbcyHoEFdFybCsgDvfyYn'; then
79 at_home=true
80 fi
81 echo "$0: at_home = $at_home"
82
83 source /a/bin/bash_unpublished/source-semi-priv
84 #### begin convert private hostnames to public hostnames ####
85 #if ! $at_home; then
86 # for var in old_host new_host; do
87 # case ${!var} in
88 # tp)
89 # eval $var=$HOME_DOMAIN
90 # ;;
91 # esac
92 # done
93 #fi
94 #### end convert private hostnames to public hostnames ####
95
96
97 # because our port forward is not robust enough, we can't use proxy command,
98 # todo: setup vpn so this is all taken care of.
99 if ! $update_wrt; then
100 wrt_shell=:
101 else
102 wrt_shell="ssh wrt.b8.nz"
103 fi
104
105 btrbk_test="systemctl is-active btrbk.service"
106 while $new_shell $btrbk_test || $old_shell $btrbk_test; do
107 echo "$0: btrbk is running on new or old host. sleeping for 8 seconds"
108 sleep 6
109 echo "$0: testing for btrbk activity in 2 seconds"
110 sleep 2
111 done
112
113 new_hostname=$($new_shell hostname)
114
115 ########### end initial processing, begin actually modifying things ##########
116
117 restore_new_btrbk=false
118 if $new_shell systemctl is-active btrbk.timer; then
119 $new_shell sudo systemctl stop btrbk.timer
120 restore_new_btrbk=true
121 fi
122 restore_old_btrbk=false
123 if $old_shell systemctl is-active btrbk.timer; then
124 $old_shell sudo systemctl stop btrbk.timer
125 restore_old_btrbk=true
126 fi
127
128
129 $new_shell bash -xs <<'EOF'
130 set -eE
131 if mountpoint -q /m; then sudo umount /m; fi
132 if mountpoint -q /o; then sudo umount /o; fi
133 EOF
134
135 # if new_host is not on home network, make mail.iankelling.org not resolve
136 # on the home network.
137 if [[ $new_host == $HOSTNAME ]] && ! $at_home; then
138 echo | $wrt_shell cedit mail_host /etc/hosts || [[ $? == 1 ]] # 1 means file changed.
139 else
140 $wrt_shell bash -xs $new_host <<'EOFOUTER'
141 new_host=$1
142 cedit mail_host /etc/hosts <<EOF || /etc/init.d/dnsmasq restart
143 $(grep "\b$new_hostname\b" /etc/hosts | awk '{print $1}') mail.iankelling.org
144 EOF
145 EOFOUTER
146 fi
147
148 $old_shell primary-setup $new_hostname
149
150 /a/bin/distro-setup/install-my-scripts
151
152 if $localhost_new; then
153 btrbk-run -s $old_host -m /o
154 else
155 btrbk-run -t $new_host -m /o
156 fi
157
158 $new_shell primary-setup $new_hostname
159
160 if $restore_new_btrbk; then
161 $new_shell sudo systemctl start btrbk.timer
162 fi
163 if $restore_old_btrbk; then
164 $old_shell sudo systemctl start btrbk.timer
165 fi